////////////////////////////////////////////////////////////////
// 					DCF BigClock
//				 Topor Zoltn - 2007. mrc.
//			   http://www.hobbielektronika.hu/
////////////////////////////////////////////////////////////////
#include <16F873A.h>
#FUSES NOWDT, HS, NOPUT, NOPROTECT, BROWNOUT, NOLVP, NOCPD
#use delay(clock=20000000)
//#use rs232(baud=500,parity=N,rcv=PIN_A0,bits=8,stream=radio)

#define DAL_SCL   PIN_B4
#define DAL_SDA   PIN_B5

#define CAP_PIN	  PIN_A0

#use i2c(master,sda=DAL_SDA, scl=DAL_SCL, FORCE_HW)

#define XTAL_FREQUENCY  20000000
#define TIMER1_FREQUENCY (XTAL_FREQUENCY / 4)      // 20000000/4

#define SZD	"%02u"

int16 TickCount	= 0;
int32 Ticker;
boolean NeedMeasureTemp = true;
signed int temp_h;
int temp_l;

int act_disp_counter = 0;
int act_disp = 0;
boolean volt_mar_dcf = false;

#include <display.c>
#include <m_dcf77.c>
//#include <m_manchester.c>
#include <m_DS1621M.C>

//===========================================================================
void chtime() {
//===========================================================================
	time.sec++;
	act_disp_counter++;
	if(act_disp_counter == 3) {
		act_disp++;
		if(act_disp == 3) act_disp = 0;
		act_disp_counter = 0;
	}
	if(time.sec == 60) {
		time.sec = 0;
		time.minute++;
		NeedMeasureTemp = true;
		if(time.minute == 60) {
			time.minute = 0;
			time.hour++;
			if(time.hour == 24) {
				time.hour = 0;
			}
		}
	}
}


//===========================================================================
void Initialize_RTC(void) {
//===========================================================================
  Ticker = TIMER1_FREQUENCY;
  setup_timer_1( T1_INTERNAL | T1_DIV_BY_1 );

  enable_interrupts( INT_TIMER1 );
} 

//===========================================================================
#int_RTCC
void RTCC_isr() {
//===========================================================================
RedrawDisplay();
}

//===========================================================================
#int_TIMER1                               
void TIMER1_isr()                         
//===========================================================================
{
  Ticker -= 65535;
  if ( Ticker < 65536 ) {
     Ticker += TIMER1_FREQUENCY;
     chtime();
  }
} 

//===========================================================================
#int_timer2
void isr_timer2(void) {
//===========================================================================
	TickCount++;
	if(TickCount==150) {
		dcf77_get_input();
	}
}

//======================================================================
#int_EXT
void EXT_isr() {
//======================================================================
	dcf77_isr();
}

//======================================================================
void init() {
//======================================================================
	input(PIN_B0);

	ext_int_edge(L_TO_H);

	init_temp(0);
	setup_timer_0(RTCC_INTERNAL|RTCC_DIV_16);
	setup_timer_2(T2_DIV_BY_4,78,16);
	Initialize_RTC();
	enable_interrupts(INT_TIMER2);
	enable_interrupts(INT_RTCC); 
	enable_interrupts(INT_EXT);
	enable_interrupts(GLOBAL);

	TickCount = 0;
	dcf_index = 0;

	time.hour = 12;
	time.minute = 0;
	time.sec = 0;

	set_tris_c(0x00000000);
}

//======================================================================
void DisplayTime(){
//======================================================================
	display_putc("\f");
	printf(display_putc,SZD,time.hour);	
	display_putc(":");
	printf(display_putc,SZD,time.minute);	
	display_putc(":");
	printf(display_putc,SZD,time.sec);	
	if(!volt_mar_dcf) {
		if(input(PIN_B0)) display_putc(".");
	}
}

//======================================================================
void DisplayTemp(){
//======================================================================
	printf(display_putc,"\f%d",temp_h);
	if(bit_test(temp_l,7)) {
		display_putc(".5");
	} else {
		display_putc(".0");
	}
	display_putc(" C");
}

//======================================================================
void main() {
//======================================================================
	init();
	for(;;) {
		if (dcf_time.HasNewTime) {
			dcf_time.HasNewTime = false;
			Ticker = TIMER1_FREQUENCY;
			time = dcf_time;
			time.sec = 1;//ez mr csak az j perc elsjnl
						 //fog beesni
			volt_mar_dcf = true;//tbbet nem nullzdik perckezdetnl
			NeedMeasureTemp = true;
		}

		if(NeedMeasureTemp) {
			NeedMeasureTemp = false;
			temp_h = read_high_temp(0);	
			temp_l = read_low_temp(0);
		}

		if(act_disp<2) DisplayTime();
		else if(act_disp == 2) DisplayTemp();

		FlipBuffer();
		delay_ms(10);
	}
}
